# This file is a template, and might need editing before it works on your project.
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Nodejs.gitlab-ci.yml

# Official framework image. Look for the different tagged releases at:
# https://hub.docker.com/r/library/node/tags/
image: node:16.14.0

variables:
  GIT_DEPTH: '0'
  DOCKER_HOST: tcp://docker:2375/
  CI_REGISTRY_USER: ricardo.santa
  DOCKER_CI_TOKEN: 2035GitLab

before_script:
  - apt-get update
  - apt-get install zip

stages:
  - install-dependencies
  - build
  - docker-image-creation
  - deploy


install-dependencies:
  stage: install-dependencies
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - node_modules/
      - dist/
  script:
    - npm ci
  only:
    changes:
      - package-lock.json

build:
  stage: build
  script:
    - npm run build
    - cd dist/${PROJECT_NAME}
    - ls -al -F
    - echo "BUILD SUCCESSFUL"
  dependencies:
    - install-dependencies
  cache: 
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - node_modules/
    policy: pull
  only:
    - desarrollo
#    changes:
#      - src/*
#      - angular.json  
  artifacts:
    when: on_success
    paths:
      - dist/${PROJECT_NAME} 

docker_image-creation:
  image: docker:git # image with docker installed to execute docker commands
  stage: docker-image-creation # notice a new 
  cache:
    policy: pull
  services:
    - docker:dind #used to be able to execute docker commands inside of a docker container
  before_script:
    - docker ps #overrides previous docker script
  script:
    - docker login -u $CI_REGISTRY_USER -p $DOCKER_CI_TOKEN registry.gitlab.com #logs into gitlab docker registery, make sure to have this variables defined
    - docker build -t registry.gitlab.com/ricardo.santa/angularapp . # creates a docker image
    - docker push registry.gitlab.com/ricardo.santa/angularapp # pushes the create docker image to docker registry
  dependencies:
    - build 